Name: nagios
Version: 1.2
Release: alt1

%define nagios_usr nagios
%define nagios_grp nagios
%define httpd_grp apache

%define alter_files avail.cgi cmd.cgi config.cgi extinfo.cgi histogram.cgi history.cgi notifications.cgi outages.cgi showlog.cgi status.cgi statusmap.cgi statuswml.cgi statuswrl.cgi summary.cgi tac.cgi trends.cgi

Summary: Services and network monitoring system
Summary(ru_RU.KOI8-R):     .
License: GPL
Group: Monitoring
URL: http://www.nagios.org

Source0: %name-%version.tar.gz

# Apache config for Nagios(R)
Source1: %name.conf

# Apache user/password file for Nagios(R)
# contains defaults: user=nagios, password=nagios
Source2: %name.web-users

# init-script for Nagios(R)
Source3: %name.init

# fix some default paths
Patch10: %name-1.0-alt-makefile.patch

# fix default config.files
Patch11: %name-1.0-alt-config.patch.bz2

# code cleanup  - compile warnings, simple bugs
Patch12: %name-1.2-alt-warnings.patch.bz2

# scripts cleanup - paths, simple bugs
Patch13: %name-1.0-alt-scripts.patch

# Automatically added by buildreq on Sun Apr 18 2004
BuildRequires: XFree86-libs freetype2 libMySQL-devel libalternatives-devel
BuildRequires: libgd2-devel libjpeg-devel libpng-devel libpq3-devel postgresql-devel zlib-devel
BuildRequires: traceroute xpm

%description
Nagios(R) is a host and service monitor designed to inform you of network
problems before your clients, end-users or managers do. It has been
designed to run under the Linux operating system, but works fine under
most *NIX variants as well. The monitoring daemon runs intermittent
checks on hosts and services you specify using external "plugins" which
return status information to Nagios(R). When problems are encountered, the
daemon can send notifications out to administrative contacts in a variety
of different ways (email, instant message, SMS, etc.). Current status
information, historical logs, and reports can all be accessed via a web
browser.

%description -l ru_RU.KOI8-R
Nagios(R)      ,  
-             
  . Nagios(R)       Linux, 
      *NIX- .  
/       - "plug-ins".
   ,     
   web-.

%package common
Summary: Services and network monitor, common files
Summary(ru_RU.KOI8-R):     ,  
Group: Monitoring
PreReq: alternatives >= 0.0.6

%description common
Nagios(R) is a host and service monitor designed to inform you of network
problems before your clients, end-users or managers do. It has been
designed to run under the Linux operating system, but works fine under
most *NIX variants as well. The monitoring daemon runs intermittent
checks on hosts and services you specify using external "plugins" which
return status information to Nagios(R). When problems are encountered, the
daemon can send notifications out to administrative contacts in a variety
of different ways (email, instant message, SMS, etc.). Current status
information, historical logs, and reports can all be accessed via a web
browser.

%description common -l ru_RU.KOI8-R
Nagios(R)      ,  
-             
  . Nagios(R)       Linux, 
      *NIX- .  
/       - "plug-ins".
   ,     
   web-.

%package www-common
Summary: Services and network monitor, common files for web-interface
Summary(ru_RU.KOI8-R):     ,    web-
Group: Monitoring
PreReq: %name-common = %version-%release

%description www-common
Nagios(R) is a host and service monitor designed to inform you of network
problems before your clients, end-users or managers do. It has been
designed to run under the Linux operating system, but works fine under
most *NIX variants as well. The monitoring daemon runs intermittent
checks on hosts and services you specify using external "plugins" which
return status information to Nagios(R). When problems are encountered, the
daemon can send notifications out to administrative contacts in a variety
of different ways (email, instant message, SMS, etc.). Current status
information, historical logs, and reports can all be accessed via a web
browser.

%description www-common -l ru_RU.KOI8-R
Nagios(R)      ,  
-             
  . Nagios(R)       Linux, 
      *NIX- .  
/       - "plugins".
   ,     
   web-.


%package default
Summary: Services and network monitor
Summary(ru_RU.KOI8-R): C    
Group: Monitoring
###########################################
# Provide the abstract service names (which are virtual pkg names),
# specify their origin (our pkg name as the epoch + version-release):
Provides: nagios
Provides: nagios-daemon = %name:%version-%release
Obsoletes: nagios < %version-%release

# Conflict with all other real pkgs which provide the same services
# (they should specify the origin the same way, so the epoch-version-release
# of the virtual pkgs POP3D & IMAPD will always differ from that of ours if
# they are provided by a different real pkg):
Conflicts: nagios-daemon < %name:%version-%release
Conflicts: nagios-daemon > %name:%version-%release
#
########################################
PreReq: %name-common = %version-%release
Requires: nagios-plugins


%description default
Nagios(R) is a host and service monitor designed to inform you of network
problems before your clients, end-users or managers do. It has been
designed to run under the Linux operating system, but works fine under
most *NIX variants as well. The monitoring daemon runs intermittent
checks on hosts and services you specify using external "plugins" which
return status information to Nagios(R). When problems are encountered, the
daemon can send notifications out to administrative contacts in a variety
of different ways (email, instant message, SMS, etc.). Current status
information, historical logs, and reports can all be accessed via a web
browser.

%description default -l ru_RU.KOI8-R
Nagios(R)      ,  
-             
  . Nagios(R)       Linux, 
      *NIX- .  
/       - "plugins".
   ,     
   web-.


%package default-www
Summary: Services and network monitor, web-interface
Summary(ru_RU.KOI8-R): C    , web-
Group: Monitoring
PreReq: %name-default = %version-%release, %name-www-common = %version-%release

%description default-www
Nagios(R) is a host and service monitor designed to inform you of network
problems before your clients, end-users or managers do. It has been
designed to run under the Linux operating system, but works fine under
most *NIX variants as well. The monitoring daemon runs intermittent
checks on hosts and services you specify using external "plugins" which
return status information to Nagios(R). When problems are encountered, the
daemon can send notifications out to administrative contacts in a variety
of different ways (email, instant message, SMS, etc.). Current status
information, historical logs, and reports can all be accessed via a web
browser.
This package contains a CGI-scripts for version of Nagios(R) with MySQL
support.

%description default-www -l ru_RU.KOI8-R
Nagios(R)      ,  
-             
  . Nagios(R)       Linux, 
      *NIX- .  
/       - "plugins".
   ,     
   web-.
   CGI-  web-  Nagios(R).


%package mysql
Summary: Services and network monitor with MySQL support
Summary(ru_RU.KOI8-R): C       MySQL
Group: Monitoring
###########################################
# Provide the abstract service names (which are virtual pkg names),
# specify their origin (our pkg name as the epoch + version-release):
Provides: nagios
Provides: nagios-daemon = %name:%version-%release

# Conflict with all other real pkgs which provide the same services
# (they should specify the origin the same way, so the epoch-version-release
# of the virtual pkgs POP3D & IMAPD will always differ from that of ours if
# they are provided by a different real pkg):
Conflicts: nagios-daemon < %name:%version-%release
Conflicts: nagios-daemon > %name:%version-%release
#
########################################
PreReq: %name-common = %version-%release
Requires: nagios-plugins
Obsoletes: nagios < %version-%release

%description mysql
Nagios(R) is a host and service monitor designed to inform you of network
problems before your clients, end-users or managers do. It has been
designed to run under the Linux operating system, but works fine under
most *NIX variants as well. The monitoring daemon runs intermittent
checks on hosts and services you specify using external "plugins" which
return status information to Nagios(R). When problems are encountered, the
daemon can send notifications out to administrative contacts in a variety
of different ways (email, instant message, SMS, etc.). Current status
information, historical logs, and reports can all be accessed via a web
browser.
This package is contains a version of Nagios(R)(R) with MySQL support for
storing status info, comments and other data into MySQL databases.

%description mysql -l ru_RU.KOI8-R
Nagios(R)      ,  
-             
  . Nagios(R)       Linux, 
      *NIX- .  
/       - "plugins".
   ,     
   web-.
    Nagios(R),   
   //  SQL- MySQL.


%package mysql-www
Summary: Services and network monitor with MySQL support, web-interface
Summary(ru_RU.KOI8-R): C       MySQL, web-
Group: Monitoring
PreReq: %name-mysql = %version-%release, %name-www-common = %version-%release

%description mysql-www
Nagios(R) is a host and service monitor designed to inform you of network
problems before your clients, end-users or managers do. It has been
designed to run under the Linux operating system, but works fine under
most *NIX variants as well. The monitoring daemon runs intermittent
checks on hosts and services you specify using external "plugins" which
return status information to Nagios(R). When problems are encountered, the
daemon can send notifications out to administrative contacts in a variety
of different ways (email, instant message, SMS, etc.). Current status
information, historical logs, and reports can all be accessed via a web
browser.
This package contains a CGI-scripts for version of Nagios(R) with MySQL
support.

%description mysql-www -l ru_RU.KOI8-R
Nagios(R)      ,  
-             
  . Nagios(R)       Linux, 
      *NIX- .  
/       - "plugins".
   ,     
   web-.
   CGI-  web-  Nagios(R) (  
 MySQL).


%package pgsql
Summary: Services and network monitor with PostgreSQL support
Summary(ru_RU.KOI8-R): C       PostgreSQL
Group: Monitoring
###########################################
# Provide the abstract service names (which are virtual pkg names),
# specify their origin (our pkg name as the epoch + version-release):
Provides: nagios
Provides: nagios-daemon = %name:%version-%release

# Conflict with all other real pkgs which provide the same services
# (they should specify the origin the same way, so the epoch-version-release
# of the virtual pkgs POP3D & IMAPD will always differ from that of ours if
# they are provided by a different real pkg):
Conflicts: nagios-daemon < %name:%version-%release
Conflicts: nagios-daemon > %name:%version-%release
#
########################################
PreReq: %name-common = %version-%release
Requires: nagios-plugins
Obsoletes: nagios < %version-%release

%description pgsql
Nagios(R) is a host and service monitor designed to inform you of network
problems before your clients, end-users or managers do. It has been
designed to run under the Linux operating system, but works fine under
most *NIX variants as well. The monitoring daemon runs intermittent
checks on hosts and services you specify using external "plugins" which
return status information to Nagios(R). When problems are encountered, the
daemon can send notifications out to administrative contacts in a variety
of different ways (email, instant message, SMS, etc.). Current status
information, historical logs, and reports can all be accessed via a web
browser.
This package is contains a version of Nagios(R)(R) with PostgreSQL support
for storing status info, comments and other data into MySQL databases.

%description pgsql -l ru_RU.KOI8-R
Nagios(R)      ,  
-             
  . Nagios(R)       Linux, 
      *NIX- .  
/       - "plugins".
   ,     
   web-.
    Nagios(R),   
   //  SQL- PostgreSQL.


%package pgsql-www
Summary: Services and network monitor with PostgreSQL support, web-interface
Summary(ru_RU.KOI8-R): C       PostgreSQL, web-
Group: Monitoring
PreReq: %name-pgsql = %version-%release, %name-www-common = %version-%release

%description pgsql-www
Nagios(R) is a host and service monitor designed to inform you of network
problems before your clients, end-users or managers do. It has been
designed to run under the Linux operating system, but works fine under
most *NIX variants as well. The monitoring daemon runs intermittent
checks on hosts and services you specify using external "plugins" which
return status information to Nagios(R). When problems are encountered, the
daemon can send notifications out to administrative contacts in a variety
of different ways (email, instant message, SMS, etc.). Current status
information, historical logs, and reports can all be accessed via a web
browser.
This package contains a CGI-scripts for version of Nagios(R) with PostgreSQL
support.

%description pgsql-www -l ru_RU.KOI8-R
Nagios(R)      ,  
-             
  . Nagios(R)       Linux, 
      *NIX- .  
/       - "plugins".
   ,     
   web-.
   CGI-  web-  Nagios(R) (  
 PostgreSQL).

%prep
%setup -q -n %name-%version
%patch10 -p1
%patch11 -p1
%patch12 -p1
%patch13 -p1

%build
PATH=$PATH:/usr/sbin
confargs_default="--with-template-extinfo"
confargs_mysql="--with-mysql-xdata"
confargs_pgsql="--with-pgsql-xdata"
for xdatasrc in mysql pgsql default; do
xdataargs=`eval echo \\$confargs_$xdatasrc`
%configure \
	--with-nagios-user=%nagios_usr \
	--with-nagios-grp=%nagios_grp \
	--with-command-user=%nagios_usr \
	--with-command-grp=%nagios_grp \
	--with-cgiurl=/%name/cgi-bin \
	--with-htmurl=/%name \
	--with-init-dir=%_initdir \
	--with-lockfile=/var/run/%name.pid \
	--with-mail=/bin/mail \
	--with-template-objects \
	--with-template-extinfo \
	--with-default-perfdata \
	$xdataargs

%make_build all
cd contrib
%make_build all
cd ..

%__cp base/nagios base/nagios-$xdatasrc
pushd cgi
	%__mkdir $xdatasrc
	for file in *.cgi ; do
		%__cp $file $xdatasrc/$file
	done
popd

if [ $xdatasrc != "default" ] ; then
	%make_build clean
fi
done

%install
make DESTDIR=%buildroot install
make DESTDIR=%buildroot install-config
make DESTDIR=%buildroot install-commandmode

%__mkdir_p %buildroot/%_initrddir
%__install -m 0755 %SOURCE3 %buildroot/%_initrddir/%name

%__rm -f %buildroot/%_sbindir/%name
%__rm -rf %buildroot/%_libdir/%name/cgi

for xdatasrc in mysql pgsql default ; do
 %__install -m 755 base/nagios-$xdatasrc %buildroot/%_sbindir
 pushd cgi/$xdatasrc
  %__mkdir %buildroot/%_libdir/%name/cgi-$xdatasrc
  for file in * ; do
   %__install -m 755 $file %buildroot/%_libdir/%name/cgi-$xdatasrc
  done
 popd
done

%__mkdir_p -m 0755 %buildroot/%_docdir/%name-%version

# install contrib tools and docs
pushd contrib
 %__mkdir_p -m 0755 %buildroot/%_libexecdir/%name/contrib
 %__install -m 0755 daemonchk.cgi %buildroot/%_libexecdir/%name/contrib
 %__install -m 0755 traceroute.cgi %buildroot/%_libexecdir/%name/contrib
 %__install -m 0644 README %buildroot/%_docdir/%name-%version/README.contrib
 %__install -m 0644 database/README %buildroot/%_docdir/%name-%version/README.database
 %__install -m 0644 database/create_mysql %buildroot/%_docdir/%name-%version
 %__install -m 0644 database/create_pgsql %buildroot/%_docdir/%name-%version
popd

# install eventhandlers
%__mkdir_p -m 0755 %buildroot/%_libexecdir/%name/eventhandlers
pushd contrib/eventhandlers
 for file in `/bin/find ./ -type f -print` ; do
  %__install -m 0755 $file %buildroot/%_libexecdir/%name/eventhandlers
 done

 for dir in {distributed-monitoring,redundancy-scenario1} ; do
  %__mkdir_p -m 0755 %buildroot/%_libexecdir/%name/eventhandlers/$dir
  cd $dir
  for file in `/bin/find ./ -type f -print` ; do
   %__install -m 0755 $file %buildroot/%_libexecdir/%name/eventhandlers/$dir
  done
  cd ..
 done
popd

#instal docs
%__install -m 0644 Changelog %buildroot/%_docdir/%name-%version
%__install -m 0644 INSTALLING %buildroot/%_docdir/%name-%version
%__install -m 0644 LEGAL %buildroot/%_docdir/%name-%version
%__install -m 0644 README %buildroot/%_docdir/%name-%version
%__install -m 0644 UPGRADING %buildroot/%_docdir/%name-%version
%__install -m 0644 daemon-init %buildroot/%_docdir/%name-%version/nagios.init
%__install -m 0644 contrib/htaccess.sample %buildroot/%_docdir/%name-%version

# misc 
%__mkdir_p %buildroot/%_localstatedir/%name/tmp
%__mkdir_p %buildroot/var/run
/bin/touch %buildroot/var/run/%name.pid

# install web-server configs
%__mkdir_p -m 0755 %buildroot/%_sysconfdir/httpd/conf
%__install -m 0644 %SOURCE1 %buildroot/%_sysconfdir/httpd/conf
%__install -m 0640 %SOURCE2 %buildroot/%_sysconfdir/%name


#alternatives support
%__install -d %buildroot/%_altdir
>%buildroot/%_altdir/%name
for i in default mysql pgsql; do
%__cat <<EOF >>%buildroot/%_altdir/%name
<group name="candidate">
    <option name="link">%_sbindir/%name</option>
    <option name="real">%_sbindir/%name-$i</option>
    <option name="weight" type="number">WEIGHT-$i</option>
    <group name="slave">
        <option name="link">%_libdir/%name/cgi</option>
        <option name="real">%_libdir/%name/cgi-$i</option>
    </group>
</group>
EOF
done

#setup weights
%__subst 's,WEIGHT-default,30,' %buildroot/%_altdir/%name
%__subst 's,WEIGHT-mysql,20,'   %buildroot/%_altdir/%name
%__subst 's,WEIGHT-pgsql,10,'   %buildroot/%_altdir/%name

#for moving to other alternatives scheme
%pre www-common
if [ ! -L %_libdir/%name/cgi ] ; then
  if [ -d %_libdir/%name/cgi ] ; then
    %__rm -rf %_libdir/%name/cgi
  fi
fi

%post www-common
if [ $1 = "1" ]; then
 echo "Include conf/nagios.conf" >> %_sysconfdir/httpd/conf/httpd.conf
fi
if [ -f %_sbindir/apachectl ] ; then
 %_sbindir/apachectl update
fi

%preun www-common
if [ $1 = "0" ]; then
  %__subst "s|^Include conf/nagios.conf$||g;" \
     %_sysconfdir/httpd/conf/httpd.conf
fi

%postun www-common
if [ -x %_sbindir/apachectl ] ; then
 %_sbindir/apachectl update
fi

%pre common
%_sbindir/groupadd -r -f %nagios_grp &>/dev/null
%_sbindir/useradd -r -n -g %nagios_grp -d %_localstatedir/%name \
    -s /bin/false -c 'Nagios(R) account' %nagios_usr &>/dev/null ||:

%post common
%post_service %name
%register_alternatives %name -- %name %alter_files

%preun common
%preun_service %name
%unregister_alternatives %name

%post default
%update_alternatives
%preun default
%remove_alternatives %_sbindir/%name-default

%post mysql
%update_alternatives
%preun mysql
%remove_alternatives %_sbindir/%name-mysql

%post pgsql
%update_alternatives
%preun pgsql
%remove_alternatives %_sbindir/%name-pgsql

%post default-www
%update_alternatives
%preun default-www
%remove_alternatives %_libdir/%name/cgi-default

%post mysql-www
%update_alternatives
%preun mysql-www
%remove_alternatives %_libdir/%name/cgi-mysql

%post pgsql-www
%update_alternatives
%preun pgsql-www
%remove_alternatives %_libdir/%name/cgi-pgsql

%files common
%attr(3775,root,%nagios_grp) %dir %_localstatedir/%name
%_altdir/%name
%_initrddir/%name
# configs
%dir %_sysconfdir/%name
%attr(0640,root,%nagios_grp) %config(noreplace) %_sysconfdir/%name/resource.cfg
%config(noreplace) %_sysconfdir/%name/nagios.cfg
%config(noreplace) %_sysconfdir/%name/checkcommands.cfg
%config(noreplace) %_sysconfdir/%name/contactgroups.cfg
%config(noreplace) %_sysconfdir/%name/contacts.cfg
%config(noreplace) %_sysconfdir/%name/dependencies.cfg
%config(noreplace) %_sysconfdir/%name/escalations.cfg
%config(noreplace) %_sysconfdir/%name/hostgroups.cfg
%config(noreplace) %_sysconfdir/%name/hosts.cfg
%config(noreplace) %_sysconfdir/%name/misccommands.cfg
%config(noreplace) %_sysconfdir/%name/services.cfg
%config(noreplace) %_sysconfdir/%name/timeperiods.cfg
# lib stuff
%dir %_libdir/%name
%dir %_libdir/%name/contrib
%dir %_libdir/%name/eventhandlers
%_libdir/%name/contrib/*
%_libdir/%name/eventhandlers/*
# docs
%dir %_docdir/%name-%version
%_docdir/%name-%version/*
# var data
%attr(0644,%nagios_usr,%nagios_grp) /var/run/%name.pid
%attr(2750,%nagios_usr,%httpd_grp) %dir %_localstatedir/%name/rw
%attr(0700,%nagios_usr,%nagios_grp) %dir %_localstatedir/%name/tmp
%attr(0750,%nagios_usr,%httpd_grp) %dir %_logdir/%name
%attr(0750,%nagios_usr,%httpd_grp) %dir %_logdir/%name/archives

%files www-common
%config(noreplace) %_sysconfdir/%name/cgi.cfg
%attr(0640,root,apache) %config(noreplace) %_sysconfdir/%name/%name.web-users
%config(noreplace) %_sysconfdir/httpd/conf/nagios.conf
%dir %_libdir/%name
# html data
%dir %_datadir/%name
%dir %_datadir/%name/html
%_datadir/%name/html/*


%files default
%_sbindir/%name-default

%files default-www
%dir %_libdir/%name
%dir %_libdir/%name/cgi-default
%_libdir/%name/cgi-default/*

%files mysql
%_sbindir/%name-mysql

%files mysql-www
%dir %_libdir/%name
%dir %_libdir/%name/cgi-mysql
%_libdir/%name/cgi-mysql/*

%files pgsql
%_sbindir/%name-pgsql

%files pgsql-www
%dir %_libdir/%name
%dir %_libdir/%name/cgi-pgsql
%_libdir/%name/cgi-pgsql/*


%changelog
* Sun Apr 18 2004 Dmitry Lebkov <dlebkov@altlinux.ru> 1.2-alt1
- v1.2 -- bugfix release

* Wed Dec 17 2003 Dmitry Lebkov <dlebkov@altlinux.ru> 1.1-alt2
- spec-file fixes

* Thu Jul 03 2003 Dmitry Lebkov <dlebkov@altlinux.ru> 1.1-alt1
- v1.1
- fix bugs #2605 and #2672
- init-script changed according to new requirements

* Wed Jun 18 2003 Stanislav Ievlev <inger@altlinux.ru> 1.0-alt2.1
- move to new alternatives scheme

* Wed Apr 02 2003 Dmitry Lebkov <dlebkov@altlinux.ru> 1.0-alt2
- nagios-default-www:
  + change 'Requires:' from  nagios-mysql to nagios-default.

* Sun Mar 30 2003 Dmitry Lebkov <dlebkov@altlinux.ru> 1.0-alt1
- fix 'Provides' and 'Requires' for nagios-daemon virtual package

* Wed Feb 26 2003 Dmitry Lebkov <dlebkov@altlinux.ru> 1.0-alt0.2
- binary RPM-packages redesign
- template-based configuration support for the '-mysql' and '-pgsql' packages
- SQL-scripts for create MySQL- and PgSQL-tables placed into the %_docdir
- spec-file:
  + wrong home-dir for user nagios fixed
  + fix files/dir permissions, so CGI-scripts now can read Nagios(R) logs
    and write into the nagios.cmd file
  + add 'Provides: nagios-daemon' and 'Requires: nagios-plugins' into
    '-default', '-mysql' and '-pgsql' packages
  + cosmetic fixes

* Wed Dec 04 2002 Dmitry Lebkov <dlebkov@altlinux.ru> 1.0-alt0.1
- initial build for ALT Linux
